// C Header File
// Created 7/16/19; 4:41:56 AM

#define UP_KEY _rowread(~((short)(1<<0)))&(1<<0)
#define RIGHT_KEY _rowread(~((short)(1<<0)))&(1<<3)
#define DOWN_KEY _rowread(~((short)(1<<0)))&(1<<2)
#define LEFT_KEY _rowread(~((short)(1<<0)))&(1<<1)
#define SECOND_KEY _rowread(~((short)(1<<0)))&(1<<4)
#define ENTER_KEY _rowread(~((short)(1<<1)))&(1<<0)
#define DIAMOND_KEY _rowread(~((short)(1<<0)))&(1<<6)
#define ESC_KEY _rowread(~((short)(1<<6)))&(1<<0)
#define APPS_KEY _rowread(~((short)(1<<5)))&(1<<0)
#define F1_KEY _rowread(~((short)(1<<5)))&(1<<7)
#define F5_KEY _rowread(~((short)(1<<1)))&(1<<7)
#define PLUS_KEY _rowread(~((short)(1<<1)))&(1<<1)
#define MINUS_KEY _rowread(~((short)(1<<1)))&(1<<2)
#define BACKSPACE_KEY _rowread(~((short)(1<<2)))&(1<<6)

#define A_KEY _rowread(~((short)(1<<5)))&(1<<4)
#define B_KEY _rowread(~((short)(1<<4)))&(1<<4)
#define C_KEY _rowread(~((short)(1<<3)))&(1<<4)
#define D_KEY _rowread(~((short)(1<<2)))&(1<<4)
#define E_KEY _rowread(~((short)(1<<1)))&(1<<4)
#define F_KEY _rowread(~((short)(1<<5)))&(1<<3)
#define G_KEY _rowread(~((short)(1<<4)))&(1<<3)
#define H_KEY _rowread(~((short)(1<<3)))&(1<<3)
#define I_KEY _rowread(~((short)(1<<2)))&(1<<3)
#define J_KEY _rowread(~((short)(1<<1)))&(1<<3)
#define K_KEY _rowread(~((short)(1<<5)))&(1<<2)
#define L_KEY _rowread(~((short)(1<<4)))&(1<<2)
#define M_KEY _rowread(~((short)(1<<3)))&(1<<2)
#define N_KEY _rowread(~((short)(1<<2)))&(1<<2)
#define O_KEY _rowread(~((short)(1<<1)))&(1<<2)
#define P_KEY _rowread(~((short)(1<<5)))&(1<<1)
#define Q_KEY _rowread(~((short)(1<<4)))&(1<<1)
#define R_KEY _rowread(~((short)(1<<3)))&(1<<1)
#define S_KEY _rowread(~((short)(1<<2)))&(1<<1)
#define T_KEY _rowread(~((short)(1<<2)))&(1<<5)
#define U_KEY _rowread(~((short)(1<<1)))&(1<<1)
#define V_KEY _rowread(~((short)(1<<4)))&(1<<0)
#define W_KEY _rowread(~((short)(1<<3)))&(1<<0)
#define X_KEY _rowread(~((short)(1<<5)))&(1<<5)
#define Y_KEY _rowread(~((short)(1<<4)))&(1<<5)
#define Z_KEY _rowread(~((short)(1<<3)))&(1<<5)

#define DELAY_RATE 3
#define REPEAT_RATE 2

#define LIGHT_GRAY 0
#define DARK_GRAY 1
#define DARK 2

#define ROW 11
#define COL 13

#define DICECOL1 122
#define DICECOL2 140
#define DICEROW1 4
#define DICEROW2 22

#define DICE_BOX_X1 121
#define DICE_BOX_Y1 3
#define DICE_BOX_X2 156
#define DICE_BOX_Y2 74

#define DIR_BOX_X1 121
#define DIR_BOX_Y1 80
#define DIR_BOX_X2 156
#define DIR_BOX_Y2 96

#define MESSAGE_BOX_X1 3
#define MESSAGE_BOX_Y1 92
#define MESSAGE_BOX_X2 115
#define MESSAGE_BOX_Y2 96

#define ATTACK_CHECK (board[arow][acol].type<0&&board[urow][ucol].type>0)||(board[arow][acol].type>0&&board[urow][ucol].type<0)
#define MENU_SELECT(pos,type) (type!=ACTION)?((type!=TURN)?(DrawGrayBox(x+3,y+pos*9+3,x+51,y+pos*9+11,LIGHT_GRAY)):(DrawGrayBox(x+3,y+pos*9+3,x+33,y+pos*9+11,LIGHT_GRAY))):(DrawGrayBox(x+3,y+pos*9+3,x+39,y+pos*9+11,LIGHT_GRAY))

enum DICE_REFS
{
	DAXE,DARROW,DPANIC,DMASK
};

enum TURNS
{
	HUMAN,AI,PLAYER1,PLAYER2
};

enum UNIT_DEFINES
{
	AXE=1,BOW,INFANTRY,ARCHER,KNIGHT,KING
};

enum MESSAGE_ID
{
 EMPTY_SPACE,OCCUPIED_YOU,OCCUPIED_ENEMY,MOVE_VALID,MOVE_INVALID,
 ATTACK_VALID,ATTACK_NO_UNIT,ATTACK_YOUR_UNIT,ATTACK_INVALID,
 MENU_MOVE,MENU_TURN,MENU_ATTACK,MENU_UP,MENU_RIGHT,MENU_DOWN,MENU_LEFT,
 MENU_CONTINUE,MENU_NEW,MENU_SAVE,MENU_LOAD,MENU_CUSTOM,MENU_HELP,MENU_QUIT,MENU_EXIT
};

enum MESSAGE_BOX_MESAGES
{
	SAVE_COMPLETED,SAVE_ERROR,LOAD_COMPLETED,LOAD_ERROR
};

enum MESSAGES
{
UP=1,RIGHT,DOWN,LEFT,NONE,EXIT,QUIT,SELECT,CONTINUE,NEW,SAVE,LOAD,
CUSTOM,HELP,MOVE,TURN,ATTACK,HIGHLIGHT,END_TURN,ACTION,MAIN,SAVE_LOAD
};

typedef struct 
{
	int type;			//type of unit - use the defines such as INFANTRY - negative if it is an opponents
	int number;		//current number of soldiers in this unit
	int hp;				//number of hits it takes to kill one soldier
	int dice;			//number of attack dice per soldier
	int weapon;		//weapon the unit attack with
	int dir;			//direction the unit is facing
	BOOL attacked;//wether or not the unit has attacked 0=no 1=yes
}UNIT;

unsigned short infantry[]=
{0xFF00, 0xE080, 0x7080, 0x7880, 0x5E80, 0x2D00, 0x2B00, 0x2100,//dark plane
 0x1200, 0xC00,  0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
 0xC000, 0xFF00, 0x7F00, 0x3F00, 0x3F00, 0x1E00, 0x1E00, 0x1F00,//light plane
 0xC00,  0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0};

unsigned short archer[]=
{0x1000, 0x2800, 0xA400, 0x6400, 0x2200, 0x3200, 0x2C00, 0x2600,//dark plane
 0x2F00, 0x1200, 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
 0x0,    0x0,    0x8000, 0x4000, 0x2000, 0x1000, 0x800,  0x600,//light plane
 0x700,  0x200,  0x0,    0x0,    0x0,    0x0,    0x0,    0x0};

unsigned short knight[]=
{0x60,   0xE0,   0x1C0,  0x380,  0x700,  0x7E00, 0x1C00, 0x1C00,//dark plane
 0x2400, 0x4400, 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
 0x60,   0xE0,   0x1C0,  0x380,  0x700,  0x7E00, 0x1C00, 0x1C00,//light plane
 0x2400, 0x4400, 0x0,    0x0,    0x0,    0x0,    0x0,    0x0};

unsigned short king[]=
{0x5400, 0xFE10, 0xFE20, 0xFE40, 0x7C80, 0x100,  0xE00,  0x600,
 0xA00,  0x1000, 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
 0xFFF0, 0xABF0, 0x83F0, 0x83F0, 0xFFF0, 0xFFF0, 0xFFF0, 0xFFF0,
 0xFFF0, 0xFFF0, 0x0,    0x0,    0x0,    0x0,    0x0,    0x0};

unsigned short dice[4][32]=
{
	{0x1FF8, 0x21C4, 0x43E2, 0x8749, 0x8E71, 0x8C15, 0x8F1F, 0x8507,//axe
	 0x83CF, 0x875D, 0x8EF9, 0x9C71, 0xB801, 0x7002, 0x2004, 0x1FF8,
	 0x0,    0x1FF8, 0x3E3C, 0x7CFE, 0x79FE, 0x7BFE, 0x7BFA, 0x7FFA,
	 0x7FF2, 0x7FE6, 0x7F8E, 0x7FFE, 0x7FFE, 0x3FFC, 0x1FF8, 0x0},
	{0x1FF8, 0x2004, 0x4812, 0x9C39, 0xBE7D, 0x9E79, 0x8E71, 0x8181,//arrows
	 0x8181, 0x8241, 0x8421, 0xA815, 0xB00D, 0x781E, 0x2004, 0x1FF8,
	 0x0,    0x1FF8, 0x37EC, 0x73CE, 0x4992, 0x65A6, 0x73CE, 0x7FFE,
	 0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 0x3FFC, 0x1FF8, 0x0},
	{0x1FF8, 0x3C04, 0x5402, 0x9D2F, 0x91A5, 0x91E5, 0x8165, 0x9D2F,//panic
	 0x9401, 0x9C01, 0x95C9, 0x9509, 0x8109, 0x4102, 0x21CC, 0x1FF8,
	 0x0,    0x1FF8, 0x3FFC, 0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE,
	 0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 0x3FFC, 0x1FF8, 0x0},
	{0x1FF8, 0x3FFC, 0x7FFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,//mask
	 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x7FFE, 0x3FFC, 0x1FF8,
	 0x1FF8, 0x3FFC, 0x7FFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
	 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x7FFE, 0x3FFC, 0x1FF8}
};
 
unsigned short numbers[10][32]=
{
	{0x4000, 0xC000, 0x4000, 0x4000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0x4000, 0xC000, 0x4000, 0x4000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//one
	{0xE000, 0x2000, 0xE000, 0x8000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0x2000, 0xE000, 0x8000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//two
	{0xE000, 0x2000, 0xE000, 0x2000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0x2000, 0xE000, 0x2000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//three
	{0xA000, 0xA000, 0xE000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xA000, 0xA000, 0xE000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//four
	{0xE000, 0x8000, 0xE000, 0x2000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0x8000, 0xE000, 0x2000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//five
	{0xE000, 0x8000, 0xE000, 0xA000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0x8000, 0xE000, 0xA000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//six
	{0xE000, 0x2000, 0x2000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0x2000, 0x2000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//seven
	{0xE000, 0x2000, 0x2000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0x2000, 0x2000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//eight
	{0xE000, 0xA000, 0xE000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0xA000, 0xE000, 0x2000, 0x2000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//nine
	{0xE000, 0xE000, 0xE000, 0xE000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	 0xE000, 0xE000, 0xE000, 0xE000, 0xE000, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0},//10 full
};

unsigned short arrows[4][32]=
{
	{0x800,  0x1C00, 0x2A00, 0x800,  0x800,  0x800,  0x800,  0x800,//dark plane up
	 0x800,  0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,//light plane up
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0},
	{0x0,    0x0,    0x200,  0x100,  0xFF80, 0x100,  0x200,  0x0,//dark plane right
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,//light plane right
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0},
	{0x800,  0x800,  0x800,  0x800,  0x800,  0x800,  0x2A00, 0x1C00,//dark plane down
	 0x800,  0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,//light plane down
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0},
	{0x0,    0x0,    0x2000, 0x4000, 0xFF80, 0x4000, 0x2000, 0x0,//dark plane left
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,//light plane left
	 0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0,    0x0}
};

static UNIT board[8][9];//the board used throughout the game
static BOOL turn;
static int action;
