// C Header File
// Created 7/16/19; 4:43:49 AM

void highlight(int r,int c,int color)
{
	DrawGrayBox((c*COL)+1,(r*ROW)+1,((c*COL)+1)+(COL-2),((r*ROW)+1)+(ROW-2),color);
}//end highlight()

void direction(int r,int c)
{
	ClearGrayBox(DIR_BOX_X1+14,DIR_BOX_Y1+7,DIR_BOX_X1+22,DIR_BOX_Y1+15,DARK_GRAY);
	if(board[r][c].dir>0)
		GraySprite16(DIR_BOX_X1+14,DIR_BOX_Y1+7,arrows[board[r][c].dir-1],SPRT_XOR);
}//end direction()

void draw_unit_number(int r,int c,int number)
{
	GraySprite16(c*COL+10,r*ROW+6,numbers[number-1],SPRT_XOR);
}//end draw_unit_number()

void draw_unit(int r,int c)
{
	if(abs(board[r][c].type)!=KING)
		draw_unit_number(r,c,board[r][c].number);
	
	if(abs(board[r][c].type)==INFANTRY)
  	GraySprite16(c*COL+1,r*ROW+1,infantry,SPRT_XOR);
  else if(abs(board[r][c].type)==ARCHER)
  	GraySprite16(c*COL+1,r*ROW+1,archer,SPRT_XOR);
  else if(abs(board[r][c].type)==KNIGHT)
  	GraySprite16(c*COL+1,r*ROW+1,knight,SPRT_XOR);
  else if(abs(board[r][c].type)==KING)
  	GraySprite16(c*COL+1,r*ROW+1,king,SPRT_XOR);
  
  if(board[r][c].type<0)
  	highlight(r,c,DARK);
}//end draw_unit()

void draw_die(int pos,int die)
{
	switch(pos)
	{
		case 0:
			GraySprite16(DICECOL1,DICEROW1,dice[DMASK],SPRT_OR);
			GraySprite16(DICECOL1,DICEROW1,dice[DMASK],SPRT_XOR);
  		GraySprite16(DICECOL1,DICEROW1,dice[die],SPRT_XOR);
  		break;
  	case 1:
			GraySprite16(DICECOL2,DICEROW1,dice[DMASK],SPRT_OR);
			GraySprite16(DICECOL2,DICEROW1,dice[DMASK],SPRT_XOR);
  		GraySprite16(DICECOL2,DICEROW1,dice[die],SPRT_XOR);
  		break;
  	case 2:
			GraySprite16(DICECOL1,DICEROW2,dice[DMASK],SPRT_OR);
			GraySprite16(DICECOL1,DICEROW2,dice[DMASK],SPRT_XOR);
  		GraySprite16(DICECOL1,DICEROW2,dice[die],SPRT_XOR);
  		break;
  	case 3:
			GraySprite16(DICECOL2,DICEROW2,dice[DMASK],SPRT_OR);
			GraySprite16(DICECOL2,DICEROW2,dice[DMASK],SPRT_XOR);
  		GraySprite16(DICECOL2,DICEROW2,dice[die],SPRT_XOR);
  		break;
	}//end switch
}//end draw_die()

void draw_board(int row,int col)
{
	int r,c;
	int font;
	
	ClearGrayBox(0,0,LCD_WIDTH-1,LCD_HEIGHT-1,DARK);
	
	for(r=0;r<9;r++)
  {
  	for(c=0;c<10;c++)
  	{
  		DrawGrayLine(0,r*ROW,COL*9,r*ROW,A_NORMAL,DARK);
  		DrawGrayLine(c*COL,0,c*COL,8*ROW,A_NORMAL,DARK);
  		if(c<9&&r<8&&board[r][c].type!=0)
				draw_unit(r,c);
		}//end for
	}//end for
  
  DrawGrayRect(DICE_BOX_X1-1,DICE_BOX_Y1-1,DICE_BOX_X2+1,DICE_BOX_Y2+1,1);//dice box
	DrawGrayBox(DICE_BOX_X1,DICE_BOX_Y1,DICE_BOX_X2,DICE_BOX_Y2,LIGHT_GRAY);//colors in dice box
	DrawGrayRect(DIR_BOX_X1-1,DIR_BOX_Y1-1,DIR_BOX_X2+1,DIR_BOX_Y2+1,1);//dir box
	DrawGrayBox(DIR_BOX_X1,DIR_BOX_Y1,DIR_BOX_X2,DIR_BOX_Y2,LIGHT_GRAY);//colors in the dir box
	DrawGrayRect(MESSAGE_BOX_X1-1,MESSAGE_BOX_Y1-1,MESSAGE_BOX_X2+1,MESSAGE_BOX_Y2+1,1);//message box
	DrawGrayBox(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,MESSAGE_BOX_X2,MESSAGE_BOX_Y2,LIGHT_GRAY);//color message box
  
	highlight(row,col,DARK_GRAY);
	font=FontSetSys(F_4x6);
	SetPlane(LIGHT_PLANE);
	DrawStr(DIR_BOX_X1+2,DIR_BOX_Y1+1,"Direction",A_NORMAL);
	SetPlane(DARK_PLANE);
	DrawStr(DIR_BOX_X1+2,DIR_BOX_Y1+1,"Direction",A_NORMAL);
	FontSetSys(font);
}//end draw_board()

void unit_init(int r,int c,int type)
{
	int temp_type=abs(type);
	
	board[r][c].attacked=FALSE;
	
	if(type!=0)
	{
		if(type<0)
			board[r][c].dir=DOWN;
		else
			board[r][c].dir=UP;
	}//end if
	
	if(type==0)
	{
		board[r][c].type=0;
		board[r][c].number=0;
		board[r][c].hp=0;
		board[r][c].dice=0;
		board[r][c].weapon=0;
		board[r][c].dir=0;
	}//end if
	if(temp_type==INFANTRY)
	{
		board[r][c].type=type;
		board[r][c].number=4;
		board[r][c].hp=1;
		board[r][c].dice=1;
		board[r][c].weapon=AXE;
	}//end if
	if(temp_type==ARCHER)
	{
		board[r][c].type=type;
		board[r][c].number=4;
		board[r][c].hp=1;
		board[r][c].dice=1;
		board[r][c].weapon=BOW;
	}//end if
	if(temp_type==KNIGHT)
	{
		board[r][c].type=type;
		board[r][c].number=2;
		board[r][c].hp=2;
		board[r][c].dice=2;
		board[r][c].weapon=AXE;
	}//end if
	if(temp_type==KING)
	{
		board[r][c].type=type;
		board[r][c].number=1;
		board[r][c].hp=2;
		board[r][c].dice=2;
		board[r][c].weapon=AXE;
	}//end if
}//end unit_init()

void board_init(void)
{
	int r,c;
	for(r=0;r<8;r++)
  {
  	for(c=0;c<9;c++)
  	{
  		unit_init(r,c,0);
  		if(r==0)
  		{
  			if(c==2||c==6)//initialize an archer
  				unit_init(r,c,-ARCHER);
  			if(c==3||c==5)
  				unit_init(r,c,-KNIGHT);
  			if(c==4)
  				unit_init(r,c,-KING);
  		}//end if
  		if(r==1)
  		{
  			if(c>1&&c<7)
  				unit_init(r,c,-INFANTRY);
  		}//end if
  		
  		if(r==6)
  		{
  			if(c>1&&c<7)
  				unit_init(r,c,INFANTRY);
  		}//end if
  		if(r==7)
  		{
  			if(c==2||c==6)//initialize an archer
  				unit_init(r,c,ARCHER);
  			if(c==3||c==5)
  				unit_init(r,c,KNIGHT);
  			if(c==4)
  				unit_init(r,c,KING);
  		}//end if
  	}//end for
  }//end for
}//end board_init()

void game_init(int r,int c)
{
	turn=PLAYER1;
	action=0;
	board_init();
	draw_board(r,c);
}//end game_init()

void draw_vars(int r,int c)
{
	char buffer[50],light_screen[LCD_SIZE],dark_screen[LCD_SIZE];
	short font;
	BOOL exit=FALSE;
	
	//save each plane so it can be restored later
	memcpy(light_screen,GetPlane(LIGHT_PLANE),LCD_SIZE);
	memcpy(dark_screen,GetPlane(DARK_PLANE),LCD_SIZE);
	
	font=FontSetSys(F_4x6);
	ClearGrayBox(0,0,LCD_WIDTH-1,LCD_HEIGHT-1,DARK);
	
	if(abs(board[r][c].type)==INFANTRY)
		sprintf(buffer,"Type: Infantry");
	else if(abs(board[r][c].type)==ARCHER)
		sprintf(buffer,"Type: Infantry");
	else if(abs(board[r][c].type)==KNIGHT)
		sprintf(buffer,"Type: Knight");
	else if(abs(board[r][c].type)==KING)
		sprintf(buffer,"Type: King");
	else
		sprintf(buffer,"Type: None");
	DrawStr(0,0,buffer,A_NORMAL);
	
	sprintf(buffer,"Number: %d",board[r][c].number);
	DrawStr(0,7,buffer,A_NORMAL);
	
	sprintf(buffer,"Hp: %d",board[r][c].hp);
	DrawStr(0,14,buffer,A_NORMAL);
	
	sprintf(buffer,"Dice: %d",board[r][c].dice);
	DrawStr(0,21,buffer,A_NORMAL);
	
	if(board[r][c].weapon==AXE)
		sprintf(buffer,"Weapon: Axe");
	else if(board[r][c].weapon==BOW)
		sprintf(buffer,"Weapon: Bow");
	else
		sprintf(buffer,"Weapon: None");
	DrawStr(0,28,buffer,A_NORMAL);
	
	if(board[r][c].dir==UP)
		sprintf(buffer,"Dir: UP");
	else if(board[r][c].dir==RIGHT)
		sprintf(buffer,"Dir: RIGHT");
	else if(board[r][c].dir==DOWN)
		sprintf(buffer,"Dir: DOWN");
	else if(board[r][c].dir==LEFT)
		sprintf(buffer,"Dir: LEFT");
	else
		sprintf(buffer,"Dir: None");
	DrawStr(0,35,buffer,A_NORMAL);
	
	sprintf(buffer,"Attacked: %d",board[r][c].attacked);
	DrawStr(0,42,buffer,A_NORMAL);
	
	if(turn==PLAYER1)
		sprintf(buffer,"Turn: Player1");
	else
		sprintf(buffer,"Turn: Player2");
	DrawStr(0,56,buffer,A_NORMAL);
	
	sprintf(buffer,"Action: %d",action);
	DrawStr(0,63,buffer,A_NORMAL);
	
  FontSetSys(font);
  
	while(!exit)
	{
		if(SECOND_KEY)
		{while(SECOND_KEY);exit=TRUE;}
		else if(ENTER_KEY)
		{while(ENTER_KEY);exit=TRUE;}
		
		else if(ESC_KEY)
		{while(ESC_KEY);exit=TRUE;}
		else if(DIAMOND_KEY)
		{while(DIAMOND_KEY);exit=TRUE;}
	}//end while
	
	//restore each plane to what it was ealier
	memcpy(GetPlane(LIGHT_PLANE),light_screen,LCD_SIZE);
	memcpy(GetPlane(DARK_PLANE),dark_screen,LCD_SIZE);
	
}//end draw_vars()

BOOL valid_move(int urow,int ucol,int mrow,int mcol)
{
	int index;
	if(board[mrow][mcol].type==0)
	{
		if(abs(board[urow][ucol].type)==INFANTRY||abs(board[urow][ucol].type)==ARCHER)
		{	
			if(board[urow][ucol].dir==UP)
			{
				if(mrow==urow-1&&mcol==ucol)
					return TRUE;
			}//end if
			else if(board[urow][ucol].dir==RIGHT)
			{
				if(mrow==urow&&mcol==ucol+1)
					return TRUE;
			}//end if
			else if(board[urow][ucol].dir==DOWN)
			{
				if(mrow==urow+1&&mcol==ucol)
					return TRUE;
			}//end if
			else if(board[urow][ucol].dir==LEFT)
			{
				if(mrow==urow&&mcol==ucol-1)
					return TRUE;
			}//end if
		}//end if
		else if(abs(board[urow][ucol].type)==KNIGHT||abs(board[urow][ucol].type)==KING)
		{
			if(board[urow][ucol].dir==UP)
			{
				if(urow>mrow&&ucol==mcol)
				{
					for(index=mrow;index<urow;index++)
					{
						if(board[index][ucol].type!=0)
							return FALSE;
					}//end for
					return TRUE;
				}//end if
			}//end if
			else if(board[urow][ucol].dir==RIGHT)
			{
				if(urow==mrow&&ucol<mcol)
				{
					for(index=mcol;index>ucol;index--)
					{
						if(board[urow][index].type!=0)
							return FALSE;
					}//end for
					return TRUE;
				}//end if
			}//end if
			else if(board[urow][ucol].dir==DOWN)
			{
				if(urow<mrow&&ucol==mcol)
				{
					for(index=mrow;index>urow;index--)
					{
						if(board[index][ucol].type!=0)
							return FALSE;
					}//end for
					return TRUE;
				}//end if
			}//end if
			else if(board[urow][ucol].dir==LEFT)
			{
				if(urow==mrow&&ucol>mcol)
				{
					for(index=mcol;index<ucol;index++)
					{
						if(board[urow][index].type!=0)
							return FALSE;
					}//end for
					return TRUE;
				}//end if
			}//end if
		}//end if
	}//end if
	return FALSE;
}//end valid_move()

BOOL valid_attack(int urow,int ucol,int arow,int acol,int mode)
{
	BOOL test=FALSE;
	
	if(abs(board[urow][ucol].type)!=ARCHER)
	{
		if(board[urow][ucol].dir==UP)
		{
			if(arow==urow-1&&acol==ucol)
				test=TRUE;
		}//end if
		else if(board[urow][ucol].dir==RIGHT)
		{
			if(arow==urow&&acol==ucol+1)
				test=TRUE;
		}//end if
		else if(board[urow][ucol].dir==DOWN)
		{
			if(arow==urow+1&&acol==ucol)
				test=TRUE;
		}//end if
		else if(board[urow][ucol].dir==LEFT)
		{
			if(arow==urow&&acol==ucol-1)
				test=TRUE;
		}//end if
	}//end if
	else
	{
		if(board[urow][ucol].dir==UP)
		{
			if((arow==urow-3||arow==urow-2||arow==urow-1)&&(acol==ucol-1||acol==ucol||acol==ucol+1))
				test=TRUE;
		}//end if
		else if(board[urow][ucol].dir==RIGHT)
		{
			if((arow==urow-1||arow==urow||arow==urow+1)&&(acol==ucol+1||acol==ucol+2||acol==ucol+3))
				test=TRUE;
		}//end if
		else if(board[urow][ucol].dir==DOWN)
		{
			if((arow==urow+1||arow==urow+2||arow==urow+3)&&(acol==ucol-1||acol==ucol||acol==ucol+1))
				test=TRUE;
		}//end if
		else if(board[urow][ucol].dir==LEFT)
		{
			if((arow==urow-1||arow==urow||arow==urow+1)&&(acol==ucol-3||acol==ucol-2||acol==ucol-1))
				test=TRUE;
		}//end if
	}//end if
	
	if(test)
	{
		if(mode==ATTACK)
		{
			if(ATTACK_CHECK)
				return TRUE;
		}//end if
		else
			return TRUE;
	}//end if
	
	return FALSE;
}//end valid_attack()

void message(int message_id)
{
	short font;
	
	ClearGrayBox(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,MESSAGE_BOX_X2,MESSAGE_BOX_Y2,DARK);//clear message box
	DrawGrayBox(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,MESSAGE_BOX_X2,MESSAGE_BOX_Y2,LIGHT_GRAY);//color message box
	
	SetPlane(DARK_PLANE);
	font=FontSetSys(F_4x6);
	switch(message_id)
	{
		case(EMPTY_SPACE):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"There is nothing here!",A_NORMAL);break;
		case(OCCUPIED_YOU):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"This unit is under your control.",A_NORMAL);break;
		case(OCCUPIED_ENEMY):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"This is an enemy unit.",A_NORMAL);break;
		
		case(MOVE_VALID):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"You may move here.",A_NORMAL);break;
		case(MOVE_INVALID):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"You cant move here.",A_NORMAL);break;
		
		case(ATTACK_VALID):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"This is a valid space to attack.",A_NORMAL);break;
		case(ATTACK_NO_UNIT):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"There is no one here to attack.",A_NORMAL);break;
		case(ATTACK_YOUR_UNIT):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Dont attack your own unit!",A_NORMAL);break;
		case(ATTACK_INVALID):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"You cant attack this space.",A_NORMAL);break;
		
		case(MENU_MOVE):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Move the selected unit.",A_NORMAL);break;
		case(MENU_TURN):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Turn the selected unit.",A_NORMAL);break;
		case(MENU_ATTACK):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Attack with the selected unit.",A_NORMAL);break;
		case(MENU_UP):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Turn the unit to face up.",A_NORMAL);break;
		case(MENU_RIGHT):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Turn the unit to face right.",A_NORMAL);break;
		case(MENU_DOWN):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Turn the unit to face down.",A_NORMAL);break;
		case(MENU_LEFT):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Turn the unit to face left.",A_NORMAL);break;
		case(MENU_CONTINUE):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Continue the current game.",A_NORMAL);break;
		case(MENU_NEW):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Start a new game.",A_NORMAL);break;
		case(MENU_SAVE):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Save the current game.",A_NORMAL);break;
		case(MENU_LOAD):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Load a saved game.",A_NORMAL);break;
		case(MENU_CUSTOM):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"(Not implemented yet)",A_NORMAL);break;
		case(MENU_HELP):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"(Not implemented yet)",A_NORMAL);break;
		case(MENU_QUIT):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Quit the game.",A_NORMAL);break;
		case(MENU_EXIT):
			DrawStr(MESSAGE_BOX_X1,MESSAGE_BOX_Y1,"Exit this menu.",A_NORMAL);break;

	}//end switch
	FontSetSys(font);
}//end message()

void select_unit_message(int r,int c,int sr,int sc,int mode)
{
	if(mode==SELECT)
	{
		if(board[r][c].type==0)
			message(EMPTY_SPACE);
		else if((board[r][c].type>0&&turn==PLAYER1)||(board[r][c].type<0&&turn==PLAYER2))
			message(OCCUPIED_YOU);
		else
			message(OCCUPIED_ENEMY);	
	}//end if
	else if(mode==MOVE)
	{
		if(valid_move(sr,sc,r,c))
			message(MOVE_VALID);
		else
			message(MOVE_INVALID);
	}//end if
	else if(mode==ATTACK)
	{
		if(valid_attack(sr,sc,r,c,HIGHLIGHT))
		{
			if(valid_attack(sr,sc,r,c,ATTACK))
				message(ATTACK_VALID);
			else
			{
				if(board[r][c].type==0)
					message(ATTACK_NO_UNIT);
				else
					message(ATTACK_YOUR_UNIT);
			}//end else
		}//end if
		else
			message(ATTACK_INVALID);
	}//end if
}//end select_unit_message()

int select_unit(int *r,int *c,int mode)
{
	int sr=*r,sc=*c;
	BOOL repeat=FALSE;
	
	select_unit_message(*r,*c,sr,sc,mode);
	
	while(TRUE)
	{
		if(UP_KEY)
		{
			OSFreeTimer(USER_TIMER);
			OSRegisterTimer(USER_TIMER,DELAY_RATE);
			while(UP_KEY)
			{
				if(OSTimerExpired(USER_TIMER))
				{
					repeat=TRUE;
					highlight(*r,*c,DARK_GRAY);
					if(RIGHT_KEY)
						(*c<8)?(*c+=1):(*c=0);
					else if(LEFT_KEY)
						(*c>0)?(*c-=1):(*c=8);
					(*r>0)?(*r-=1):(*r=7);
					highlight(*r,*c,DARK_GRAY);
					direction(*r,*c);
					select_unit_message(*r,*c,sr,sc,mode);
					OSFreeTimer(USER_TIMER);
					OSRegisterTimer(USER_TIMER,REPEAT_RATE);
				}//end if
			}//end while
			if(!repeat)
			{highlight(*r,*c,DARK_GRAY);(*r>0)?(*r-=1):(*r=7);highlight(*r,*c,DARK_GRAY);direction(*r,*c);
			select_unit_message(*r,*c,sr,sc,mode);}
			else
				repeat=FALSE;
		}//end if
		
		else if(RIGHT_KEY)
		{
			OSFreeTimer(USER_TIMER);
			OSRegisterTimer(USER_TIMER,DELAY_RATE);
			while(RIGHT_KEY)
			{
				if(OSTimerExpired(USER_TIMER))
				{
					repeat=TRUE;
					highlight(*r,*c,DARK_GRAY);
					if(UP_KEY)
						(*r>0)?(*r-=1):(*r=7);
					else if(DOWN_KEY)
						(*r<7)?(*r+=1):(*r=0);
					(*c<8)?(*c+=1):(*c=0);
					highlight(*r,*c,DARK_GRAY);
					direction(*r,*c);
					select_unit_message(*r,*c,sr,sc,mode);
					OSFreeTimer(USER_TIMER);
					OSRegisterTimer(USER_TIMER,REPEAT_RATE);
				}//end if
			}//end while
			if(!repeat)
			{highlight(*r,*c,DARK_GRAY);(*c<8)?(*c+=1):(*c=0);highlight(*r,*c,DARK_GRAY);direction(*r,*c);
			select_unit_message(*r,*c,sr,sc,mode);}
			else
				repeat=FALSE;
		}//end if
		
		else if(DOWN_KEY)
		{
			OSFreeTimer(USER_TIMER);
			OSRegisterTimer(USER_TIMER,DELAY_RATE);
			while(DOWN_KEY)
			{
				if(OSTimerExpired(USER_TIMER))
				{
					repeat=TRUE;
					highlight(*r,*c,DARK_GRAY);
					if(LEFT_KEY)
						(*c>0)?(*c-=1):(*c=8);
					else if(RIGHT_KEY)
						(*c<8)?(*c+=1):(*c=0);
					(*r<7)?(*r+=1):(*r=0);
					highlight(*r,*c,DARK_GRAY);
					direction(*r,*c);
					select_unit_message(*r,*c,sr,sc,mode);
					OSFreeTimer(USER_TIMER);
					OSRegisterTimer(USER_TIMER,REPEAT_RATE);
				}//end if
			}//end while
			if(!repeat)
			{highlight(*r,*c,DARK_GRAY);(*r<7)?(*r+=1):(*r=0);highlight(*r,*c,DARK_GRAY);direction(*r,*c);
			select_unit_message(*r,*c,sr,sc,mode);}
			else
				repeat=FALSE;
		}//end if
		
		else if(LEFT_KEY)
		{
			OSFreeTimer(USER_TIMER);
			OSRegisterTimer(USER_TIMER,DELAY_RATE);
			while(LEFT_KEY)
			{
				if(OSTimerExpired(USER_TIMER))
				{
					repeat=TRUE;
					highlight(*r,*c,DARK_GRAY);
					if(UP_KEY)
						(*r>0)?(*r-=1):(*r=7);
					else if(DOWN_KEY)
						(*r<7)?(*r+=1):(*r=0);
					(*c>0)?(*c-=1):(*c=8);
					highlight(*r,*c,DARK_GRAY);
					direction(*r,*c);
					select_unit_message(*r,*c,sr,sc,mode);
					OSFreeTimer(USER_TIMER);
					OSRegisterTimer(USER_TIMER,REPEAT_RATE);
				}//end if
			}//end while
			if(!repeat)
			{highlight(*r,*c,DARK_GRAY);(*c>0)?(*c-=1):(*c=8);highlight(*r,*c,DARK_GRAY);direction(*r,*c);
			select_unit_message(*r,*c,sr,sc,mode);}
			else
				repeat=FALSE;
		}//end if
		
		else if(SECOND_KEY)
		{while(SECOND_KEY);return SELECT;}
		else if(ENTER_KEY)
		{while(ENTER_KEY);return SELECT;}
		
		else if(ESC_KEY)
		{while(ESC_KEY);return EXIT;}
		else if(DIAMOND_KEY)
		{while(DIAMOND_KEY);return EXIT;}
		
		else if(F5_KEY)
		{while(F5_KEY);return QUIT;}
		
		else if(APPS_KEY)
		{draw_vars(*r,*c);}
		
		else if(PLUS_KEY)
		{while(PLUS_KEY);OSContrastUp();}
		else if(MINUS_KEY)
		{while(MINUS_KEY);OSContrastDn();}
	}//end while
}//end select_unit()

void menu_message(int pos,int type)
{
	if(type==ACTION)
	{
		switch(pos)
		{
			case(0):message(MENU_MOVE);break;
			case(1):message(MENU_TURN);break;
			case(2):message(MENU_ATTACK);break;
			case(3):message(MENU_EXIT);break;
		}//end switch
	}//end if
	else if(type==TURN)
	{
		switch(pos)
		{
			case(0):message(MENU_UP);break;
			case(1):message(MENU_RIGHT);break;
			case(2):message(MENU_DOWN);break;
			case(3):message(MENU_LEFT);break;
			case(4):message(MENU_EXIT);break;
		}//end switch
	}//end if
	else if(type==MAIN)
	{
		switch(pos)
		{
			case(0):message(MENU_CONTINUE);break;
			case(1):message(MENU_NEW);break;
			case(2):message(MENU_SAVE);break;
			case(3):message(MENU_LOAD);break;
			case(4):message(MENU_CUSTOM);break;
			case(5):message(MENU_HELP);break;
			case(6):message(MENU_QUIT);break;
		}//end switch
	}//end if
}//end menu_message()

int choose_menu(int x,int y,int type)
{
	int choice=NONE,pos=0;
	
	menu_message(pos,type);
	
	while(choice==NONE)
		{
			if(UP_KEY)
			{
				while(UP_KEY);
				if(pos==0)
				{
					MENU_SELECT(pos,type);
					if(type==ACTION)
						pos=3;
					else if(type==TURN)
						pos=4;
					else if(type==MAIN)
						pos=6;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==1)
				{
					MENU_SELECT(pos,type);
					pos=0;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==2)
				{
					MENU_SELECT(pos,type);
					pos=1;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==3)
				{
					MENU_SELECT(pos,type);
					pos=2;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==4)
				{
					MENU_SELECT(pos,type);
					pos=3;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==5)
				{
					MENU_SELECT(pos,type);
					pos=4;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==6)
				{
					MENU_SELECT(pos,type);
					pos=5;
					MENU_SELECT(pos,type);
				}//end if
				menu_message(pos,type);
			}//end if
			
			else if(DOWN_KEY)
			{
				while(DOWN_KEY);
				if(pos==0)
				{
					MENU_SELECT(pos,type);
					pos=1;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==1)
				{
					MENU_SELECT(pos,type);
					pos=2;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==2)
				{
					MENU_SELECT(pos,type);
					pos=3;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==3)
				{
					MENU_SELECT(pos,type);
					if(type==ACTION)
						pos=0;
					else
						pos=4;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==4)
				{
					MENU_SELECT(pos,type);
					if(type==TURN)
						pos=0;
					else
						pos=5;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==5)
				{
					MENU_SELECT(pos,type);
					pos=6;
					MENU_SELECT(pos,type);
				}//end if
				else if(pos==6)
				{
					MENU_SELECT(pos,type);
					pos=0;
					MENU_SELECT(pos,type);
				}//end if
				menu_message(pos,type);
			}//end if
			
			else if(SECOND_KEY)
			{
				while(SECOND_KEY);
				if(type==ACTION)
				{
					if(pos==0)choice=MOVE;if(pos==1)choice=TURN;
					if(pos==2)choice=ATTACK;if(pos==3)choice=EXIT;
				}//end if
				else if(type==TURN)
				{
					if(pos==0)choice=UP;if(pos==1)choice=RIGHT;if(pos==2)choice=DOWN;
					if(pos==3)choice=LEFT;if(pos==4)choice=EXIT;
				}//end if
				else if(type==MAIN)
				{
					if(pos==0)choice=CONTINUE;if(pos==1)choice=NEW;if(pos==2)choice=SAVE;
					if(pos==3)choice=LOAD;if(pos==4)choice=CUSTOM;if(pos==5)choice=HELP;
					if(pos==6)choice=QUIT;
				}//end if
			}//end if
			else if(ENTER_KEY)
			{
				while(ENTER_KEY);
				if(type==ACTION)
				{
					if(pos==0)choice=MOVE;if(pos==1)choice=TURN;
					if(pos==2)choice=ATTACK;if(pos==3)choice=EXIT;
				}//end if
				else if(type==TURN)
				{
					if(pos==0)choice=UP;if(pos==1)choice=RIGHT;if(pos==2)choice=DOWN;
					if(pos==3)choice=LEFT;if(pos==4)choice=EXIT;
				}//end if
				else if(type==MAIN)
				{
					if(pos==0)choice=CONTINUE;if(pos==1)choice=NEW;if(pos==2)choice=SAVE;
					if(pos==3)choice=LOAD;if(pos==4)choice=CUSTOM;if(pos==5)choice=HELP;
					if(pos==6)choice=QUIT;
				}//end if
			}//end if
			
			else if(DIAMOND_KEY)
			{
				while(DIAMOND_KEY);
				if(type==MAIN)
					choice=CONTINUE;
				else
					choice=EXIT;
			}//end if
			else if(ESC_KEY)
			{
				while(ESC_KEY);
				if(type==MAIN)
					choice=QUIT; 
				else 
					choice=EXIT;
			}//end if
			
			else if(F5_KEY)
			{while(F5_KEY);choice=QUIT;}
		
			else if(PLUS_KEY)
			{while(PLUS_KEY);OSContrastUp();}
			else if(MINUS_KEY)
			{while(MINUS_KEY);OSContrastDn();}
			
			
		}//end while
		return choice;
}//end choose_menu()

int menu(int x,int y,int type)
{
	int choice=NONE;
	char light_screen[LCD_SIZE],dark_screen[LCD_SIZE];
	short font;
	
	//save each plane so it can be restored later
	memcpy(light_screen,GetPlane(LIGHT_PLANE),LCD_SIZE);
	memcpy(dark_screen,GetPlane(DARK_PLANE),LCD_SIZE);
	
	font=FontSetSys(F_6x8);
	
	if(type==ACTION)
	{
		ClearGrayBox(x,y,x+42,y+41,DARK);
		DrawGrayRect(x+2,y+2,x+40,y+39,1);
		MENU_SELECT(0,ACTION);
		
		SetPlane(DARK_PLANE);
		DrawStr(x+9,y+4,"MOVE",A_NORMAL);
		DrawStr(x+9,y+13,"TURN",A_NORMAL);
		DrawStr(x+3,y+22,"ATTACK",A_NORMAL);
		DrawStr(x+9,y+31,"EXIT",A_NORMAL);
	}//end if
	else if(type==TURN)
	{
		ClearGrayBox(x,y,x+36,y+50,DARK);
		DrawGrayRect(x+2,y+2,x+34,y+48,1);
		MENU_SELECT(0,TURN);
		
		SetPlane(DARK_PLANE);
		DrawStr(x+3,y+4,"UP",A_NORMAL);
		DrawStr(x+3,y+13,"RIGHT",A_NORMAL);
		DrawStr(x+3,y+22,"DOWN",A_NORMAL);
		DrawStr(x+3,y+31,"LEFT",A_NORMAL);
		DrawStr(x+3,y+40,"EXIT",A_NORMAL);
	}//end if
	else if(type==MAIN)
	{
		ClearGrayBox(x,y,x+54,y+68,DARK);
		DrawGrayRect(x+2,y+2,x+52,y+66,1);
		MENU_SELECT(0,MAIN);
		
		SetPlane(DARK_PLANE);
		DrawStr(x+3,y+4,"CONTINUE",A_NORMAL);
		DrawStr(x+3,y+13,"NEW GAME",A_NORMAL);
		DrawStr(x+15,y+22,"SAVE",A_NORMAL);
		DrawStr(x+15,y+31,"LOAD",A_NORMAL);
		DrawStr(x+9,y+40,"CUSTOM",A_NORMAL);
		DrawStr(x+15,y+49,"HELP",A_NORMAL);
		DrawStr(x+15,y+58,"QUIT",A_NORMAL);
	}//end if
  FontSetSys(font);
	choice=choose_menu(x,y,type);
	
	//restore each plane to what it was ealier
	memcpy(GetPlane(LIGHT_PLANE),light_screen,LCD_SIZE);
	memcpy(GetPlane(DARK_PLANE),dark_screen,LCD_SIZE);
	
	return choice;
}//menu()

void transfer_unit(int sr,int sc,int er,int ec)
{
	board[er][ec].type=board[sr][sc].type;
	board[er][ec].number=board[sr][sc].number;
	board[er][ec].hp=board[sr][sc].hp;
	board[er][ec].dice=board[sr][sc].dice;
	board[er][ec].weapon=board[sr][sc].weapon;
	board[er][ec].dir=board[sr][sc].dir;
	unit_init(sr,sc,0);
}//end transfer_unit()

int move_unit(int *r,int *c)
{
	int choice=NONE,row,col,sr=*r,sc=*c;
	
	for(row=0;row<8;row++)
	{
		for(col=0;col<9;col++)
		{
			if(valid_move(sr,sc,row,col))
				highlight(row,col,LIGHT_GRAY);
		}//end for
	}//end for
	
	while(choice!=QUIT&&choice!=EXIT&&choice!=MOVE)
	{
		choice=select_unit(r,c,MOVE);
		if(choice==SELECT&&valid_move(sr,sc,*r,*c))
		{
			for(row=0;row<8;row++)
			{
				for(col=0;col<9;col++)
				{
					if(valid_move(sr,sc,row,col))
						highlight(row,col,LIGHT_GRAY);
				}//end for
			}//end for
			transfer_unit(sr,sc,*r,*c);
			ClearGrayBox(sc*COL+1,sr*ROW+1,sc*COL+COL-1,sr*ROW+ROW-1,DARK);
			draw_unit(*r,*c);
			choice=MOVE;
		}//end if
		else if(choice==QUIT||choice==EXIT)
		{
			for(row=0;row<8;row++)
			{
				for(col=0;col<9;col++)
				{
					if(valid_move(sr,sc,row,col))
						highlight(row,col,LIGHT_GRAY);
				}//end for
			}//end for
		}//end if
	}//end while
	
	return choice;
}//end move_unit()

int turn_unit(int r,int c)
{
	int dir;
	dir=menu(LCD_WIDTH/2-18,LCD_HEIGHT/2-21,TURN);
	if(dir>=UP&&dir<=LEFT&&dir!=board[r][c].dir)
	{
		board[r][c].dir=dir;
		direction(r,c);
		dir=TURN;
	}//end if
	return dir;
}//end turn_unit()

int battle(int arow,int acol,int vrow,int vcol)
{
	int choice=NONE,index,temp,damage=0;
	
	randomize();
	
	for(index=0;index<(board[arow][acol].dice*board[arow][acol].number);index++)
	{
		temp=random(6);
		if(temp<3)
		{
			draw_die(index,DAXE);
			if(board[arow][acol].weapon==AXE)
				damage++;
		}//end if
		else if(temp<5)
		{
			draw_die(index,DARROW);
			if(board[arow][acol].weapon==BOW)
				damage++;
		}//end if
		else
			draw_die(index,DPANIC);
	}//end for
	
	while(damage>0)
	{
		if(damage>=board[vrow][vcol].hp)
		{	
			board[vrow][vcol].number--;
			damage-=board[vrow][vcol].hp;
		}//end if
		else
			damage=0;
	}//end for
	
	ClearGrayBox(vcol*COL+1,vrow*ROW+1,vcol*COL+COL-1,vrow*ROW+ROW-1,DARK);
	
	if(board[vrow][vcol].number<1)
		unit_init(vrow,vcol,0);
	else
		draw_unit(vrow,vcol);
	
	direction(vrow, vcol);
	highlight(vrow,vcol,DARK_GRAY);
	
	while(choice==NONE)
	{
		if(SECOND_KEY)
		{while(SECOND_KEY);choice=EXIT;}
		else if(ENTER_KEY)
		{while(ENTER_KEY);choice=EXIT;}
		
		else if(ESC_KEY)
		{while(ESC_KEY);choice=EXIT;}
		else if(DIAMOND_KEY)
		{while(DIAMOND_KEY);choice=EXIT;}
		
		else if(F5_KEY)
		{while(F5_KEY);choice=QUIT;}
		
		else if(PLUS_KEY)
		{while(PLUS_KEY);OSContrastUp();}
		else if(MINUS_KEY)
		{while(MINUS_KEY);OSContrastDn();}
	}//end while
	
	ClearGrayBox(DICE_BOX_X1,DICE_BOX_Y1,DICE_BOX_X2,DICE_BOX_Y2,DARK);//clears dice box
	DrawGrayBox(DICE_BOX_X1,DICE_BOX_Y1,DICE_BOX_X2,DICE_BOX_Y2,LIGHT_GRAY);//colors in dice box
  
  return choice;
}//end battle()

int attack_unit(int *r,int *c)
{
	int choice=NONE,sr=*r,sc=*c,row,col;
	
	if(board[sr][sc].attacked==TRUE)
		choice=EXIT;
	
	for(row=0;row<8;row++)
	{
		for(col=0;col<9;col++)
		{
			if(valid_attack(sr,sc,row,col,HIGHLIGHT))
				highlight(row,col,LIGHT_GRAY);
		}//end for
	}//end for
	
	while(choice!=QUIT&&choice!=EXIT&&choice!=ATTACK)
	{
		choice=select_unit(r,c,ATTACK);
		if(choice==SELECT&&valid_attack(sr,sc,*r,*c,ATTACK))
		{
			for(row=0;row<8;row++)
			{
				for(col=0;col<9;col++)
				{
					if(valid_attack(sr,sc,row,col,HIGHLIGHT))
						highlight(row,col,LIGHT_GRAY);
				}//end for
			}//end for
			
			choice=battle(sr,sc,*r,*c);
			board[sr][sc].attacked=TRUE;
			
			if(choice==QUIT)
				action++;
			else
				choice=ATTACK;
		}//end if
	}//end while
	
	if(choice==QUIT||choice==EXIT)
	{
		for(row=0;row<8;row++)
		{
			for(col=0;col<9;col++)
			{
				if(valid_attack(sr,sc,row,col,HIGHLIGHT))
					highlight(row,col,LIGHT_GRAY);
			}//end for
		}//end for
	}//end if
		
	return choice;
}//end attack_unit()

int message_box(int x,int y,int message)
{
	int exit=NONE;
	
	if(message==SAVE_COMPLETED)
	{
		ClearGrayBox(x,y,x+90,y+14,DARK);
		DrawGrayRect(x+2,y+2,x+88,y+12,1);
		SetPlane(LIGHT_PLANE);
		DrawStr(x+3,y+4,"SAVE COMPLETED",A_NORMAL);
		SetPlane(DARK_PLANE);
		DrawStr(x+3,y+4,"SAVE COMPLETED",A_NORMAL);
	}//end if
	else if(message==SAVE_ERROR)
	{
		ClearGrayBox(x,y,x+108,y+14,DARK);
		DrawGrayRect(x+2,y+2,x+106,y+12,1);
		SetPlane(LIGHT_PLANE);
		DrawStr(x+3,y+4,"ERROR SAVING FILE",A_NORMAL);
		SetPlane(DARK_PLANE);
		DrawStr(x+3,y+4,"ERROR SAVING FILE",A_NORMAL);
	}//end if
	else if(message==LOAD_COMPLETED)
	{
		ClearGrayBox(x,y,x+90,y+14,DARK);
		DrawGrayRect(x+2,y+2,x+88,y+12,1);
		SetPlane(LIGHT_PLANE);
		DrawStr(x+3,y+4,"LOAD COMPLETED",A_NORMAL);
		SetPlane(DARK_PLANE);
		DrawStr(x+3,y+4,"LOAD COMPLETED",A_NORMAL);
	}//end if
	else if(message==LOAD_ERROR)
	{
		ClearGrayBox(x,y,x+113,y+14,DARK);
		DrawGrayRect(x+2,y+2,x+112,y+12,1);
		SetPlane(LIGHT_PLANE);
		DrawStr(x+3,y+4,"ERROR LOADING FILE",A_NORMAL);
		SetPlane(DARK_PLANE);
		DrawStr(x+3,y+4,"ERROR LOADING FILE",A_NORMAL);
	}//end if
	
	while(exit==NONE)
	{
		if(SECOND_KEY)
		{while(SECOND_KEY);exit=EXIT;}
		else if(ENTER_KEY)
		{while(ENTER_KEY);exit=EXIT;}
		
		else if(ESC_KEY)
		{while(ESC_KEY);exit=EXIT;}
		else if(DIAMOND_KEY)
		{while(DIAMOND_KEY);exit=EXIT;}
		
		else if(F5_KEY)
		{while(F5_KEY);exit=QUIT;}
		
		else if(PLUS_KEY)
		{while(PLUS_KEY);OSContrastUp();}
		else if(MINUS_KEY)
		{while(MINUS_KEY);OSContrastDn();}
	}//end while
	return exit;
}//end message_box()

int input_str(int x,int y,char *buffer)
{
	int index,exit=NONE;
	char temp=0;
	BOOL key_pressed=FALSE;
	short font;
	
	font=FontSetSys(F_6x8);
	
	for(index=0;index<9;index++)
		buffer[index]=0;
	index=0;
	
	do
	{
			   if(A_KEY){while(A_KEY);key_pressed=TRUE;temp='A';}
		else if(B_KEY){while(B_KEY);key_pressed=TRUE;temp='B';}
		else if(C_KEY){while(C_KEY);key_pressed=TRUE;temp='C';}
		else if(D_KEY){while(D_KEY);key_pressed=TRUE;temp='D';}
		else if(E_KEY){while(E_KEY);key_pressed=TRUE;temp='E';}
		else if(F_KEY){while(F_KEY);key_pressed=TRUE;temp='F';}
		else if(G_KEY){while(G_KEY);key_pressed=TRUE;temp='G';}
		else if(H_KEY){while(H_KEY);key_pressed=TRUE;temp='H';}
		else if(I_KEY){while(I_KEY);key_pressed=TRUE;temp='I';}
		else if(J_KEY){while(J_KEY);key_pressed=TRUE;temp='J';}
		else if(K_KEY){while(K_KEY);key_pressed=TRUE;temp='K';}
		else if(L_KEY){while(L_KEY);key_pressed=TRUE;temp='L';}
		else if(M_KEY){while(M_KEY);key_pressed=TRUE;temp='M';}
		else if(N_KEY){while(N_KEY);key_pressed=TRUE;temp='N';}
		else if(O_KEY){while(O_KEY);key_pressed=TRUE;temp='O';}
		else if(P_KEY){while(P_KEY);key_pressed=TRUE;temp='P';}
		else if(Q_KEY){while(Q_KEY);key_pressed=TRUE;temp='Q';}
		else if(R_KEY){while(R_KEY);key_pressed=TRUE;temp='R';}
		else if(S_KEY){while(S_KEY);key_pressed=TRUE;temp='S';}
		else if(T_KEY){while(T_KEY);key_pressed=TRUE;temp='T';}
		else if(U_KEY){while(U_KEY);key_pressed=TRUE;temp='U';}
		else if(V_KEY){while(V_KEY);key_pressed=TRUE;temp='V';}
		else if(W_KEY){while(W_KEY);key_pressed=TRUE;temp='W';}
		else if(X_KEY){while(X_KEY);key_pressed=TRUE;temp='X';}
		else if(Y_KEY){while(Y_KEY);key_pressed=TRUE;temp='Y';}
		else if(Z_KEY){while(Z_KEY);key_pressed=TRUE;temp='Z';}
		
		else if(BACKSPACE_KEY)
		{
			while(BACKSPACE_KEY);
			if(index>0)
			{
				buffer[--index]=0;
				ClearGrayBox(x+18,y+31,x+66,y+39,DARK_GRAY);
				SetPlane(DARK_PLANE);
				DrawStr(x+18,y+32,buffer,A_NORMAL);
			}//end if
		}//end if
		
		else if(ENTER_KEY){while(ENTER_KEY);if(index>0)exit=SAVE_LOAD;}
		else if(SECOND_KEY){while(SECOND_KEY);if(index>0)exit=SAVE_LOAD;}
		
		else if(ESC_KEY){while(ESC_KEY);exit=EXIT;}
		else if(DIAMOND_KEY){while(DIAMOND_KEY);exit=EXIT;}
		
		else if(F5_KEY){while(F5_KEY);exit=QUIT;}
		
		if(key_pressed==TRUE&&index<8)
		{
			buffer[index++]=temp;
			ClearGrayBox(x+18,y+31,x+66,y+39,DARK_GRAY);
			SetPlane(DARK_PLANE);
			DrawStr(x+18,y+32,buffer,A_NORMAL);
		}//end if
		key_pressed=FALSE;
		temp=0;
	}while(exit==NONE);
	
	FontSetSys(font);
	
	for(index=0;index<8;index++)
		buffer[index]=tolower(buffer[index]);
	
	return exit;
}//end input_str()

int save_game(int x,int y)
{
	FILE *f;
	int exit=NONE;
	char buffer[9],light_screen[LCD_SIZE],dark_screen[LCD_SIZE];
	short font;
	
	//save each plane so it can be restored later
	memcpy(light_screen,GetPlane(LIGHT_PLANE),LCD_SIZE);
	memcpy(dark_screen,GetPlane(DARK_PLANE),LCD_SIZE);
	
	ClearGrayBox(x,y,x+84,y+46,DARK);
	DrawGrayRect(x+2,y+2,x+82,y+44,1);
	
	DrawGrayRect(x+17,y+30,x+67,y+40,1);
	DrawGrayBox(x+18,y+31,x+66,y+39,LIGHT_GRAY);
	
	font=FontSetSys(F_6x8);
	SetPlane(LIGHT_PLANE);
	DrawStr(x+3,y+4,"ENTER NAME OF",A_NORMAL);
	DrawStr(x+6,y+12,"GAME TO SAVE",A_NORMAL);
	DrawStr(x+6,y+20,"(8 CHAR MAX)",A_NORMAL);
	SetPlane(DARK_PLANE);
	DrawStr(x+3,y+4,"ENTER NAME OF",A_NORMAL);
	DrawStr(x+6,y+12,"GAME TO SAVE",A_NORMAL);
	DrawStr(x+6,y+20,"(8 CHAR MAX)",A_NORMAL);
	FontSetSys(font);
	
	exit=input_str(x,y,&buffer[0]);
	
	if(exit==SAVE_LOAD)
	{
		if((f=fopen(buffer,"wb")))
		{
			fwrite(&board,sizeof(UNIT),8*9,f);
			fwrite(&turn,sizeof(BOOL),1,f);
			fwrite(&action,sizeof(int),1,f);
			fputc(0,f);
			fputs("LNHT",f);
			fputc(0,f);
			fputc(OTH_TAG,f);
			fclose(f);
			exit=message_box(LCD_WIDTH/2-40,LCD_HEIGHT/2-10,SAVE_COMPLETED);
			if(exit!=QUIT)
				exit=SAVE_LOAD;
		}//end if
		else
			exit=message_box(LCD_WIDTH/2-49,LCD_HEIGHT/2-10,SAVE_ERROR);
	}//end if
	
	//restore each plane to what it was ealier
	memcpy(GetPlane(LIGHT_PLANE),light_screen,LCD_SIZE);
	memcpy(GetPlane(DARK_PLANE),dark_screen,LCD_SIZE);

	return exit;
}//end save_game()

int load_game(int x,int y)
{
	FILE *f;
	int exit=NONE;
	char buffer[9],light_screen[LCD_SIZE],dark_screen[LCD_SIZE];
	short font;
	
	//save each plane so it can be restored later
	memcpy(light_screen,GetPlane(LIGHT_PLANE),LCD_SIZE);
	memcpy(dark_screen,GetPlane(DARK_PLANE),LCD_SIZE);
	
	ClearGrayBox(x,y,x+84,y+46,DARK);
	DrawGrayRect(x+2,y+2,x+82,y+44,1);
	
	DrawGrayRect(x+17,y+30,x+67,y+40,1);
	DrawGrayBox(x+18,y+31,x+66,y+39,LIGHT_GRAY);
	
	font=FontSetSys(F_6x8);
	SetPlane(LIGHT_PLANE);
	DrawStr(x+3,y+4,"ENTER NAME OF",A_NORMAL);
	DrawStr(x+6,y+12,"GAME TO LOAD",A_NORMAL);
	DrawStr(x+6,y+20,"(8 CHAR MAX)",A_NORMAL);
	SetPlane(DARK_PLANE);
	DrawStr(x+3,y+4,"ENTER NAME OF",A_NORMAL);
	DrawStr(x+6,y+12,"GAME TO LOAD",A_NORMAL);
	DrawStr(x+6,y+20,"(8 CHAR MAX)",A_NORMAL);
  FontSetSys(font);
  
	exit=input_str(x,y,&buffer[0]);

	if(exit==SAVE_LOAD)
	{
		if((f=fopen(buffer,"rb")))
		{
			fread(&board,sizeof(UNIT),8*9,f);
			fread(&turn,sizeof(BOOL),1,f);
			fread(&action,sizeof(int),1,f);
			fclose(f);
			exit=message_box(LCD_WIDTH/2-40,LCD_HEIGHT/2-10,LOAD_COMPLETED);
			if(exit!=QUIT)
				exit=SAVE_LOAD;
		}//end if
		else
			exit=message_box(LCD_WIDTH/2-52,LCD_HEIGHT/2-10,LOAD_ERROR);
	}//end if
	
	//restore each plane to what it was ealier
	memcpy(GetPlane(LIGHT_PLANE),light_screen,LCD_SIZE);
	memcpy(GetPlane(DARK_PLANE),dark_screen,LCD_SIZE);
	
	return exit;
}//end save_game()

void save_current_game(void)
{
	FILE *f;
	if((f=fopen("current","wb")))
	{
		fwrite(&board,sizeof(UNIT),8*9,f);
		fwrite(&turn,sizeof(BOOL),1,f);
		fwrite(&action,sizeof(int),1,f);
		fputc(0,f);
		fputs("LNHT",f);
		fputc(0,f);
		fputc(OTH_TAG,f);
		fclose(f);
	}//end if
}//end save_current_game()

BOOL load_current_game(void)
{
	FILE *f;
	if((f=fopen("current","rb")))
	{
		fread(&board,sizeof(UNIT),8*9,f);
		fread(&turn,sizeof(BOOL),1,f);
		fread(&action,sizeof(int),1,f);
		fclose(f);
	}//end if
	else
		return FALSE;
	
	return TRUE;
}//end load_current_game()

int player_turn(int *r,int *c)
{
	int row,col,choice=NONE;
			
	while(action<2&&choice!=QUIT&&choice!=EXIT)
	{
		choice=select_unit(r,c,SELECT);
		if(choice==SELECT&&((turn==PLAYER1&&board[*r][*c].type>0)||(turn==PLAYER2&&board[*r][*c].type<0)))
		{
			choice=menu(LCD_WIDTH/2-21,LCD_HEIGHT/2-21,ACTION);
			if(choice==MOVE)
			{
				choice=move_unit(r,c);
				if(choice==MOVE)
					action++;
				else if(choice==EXIT)
					choice=NONE;
			}//end if
			else if(choice==TURN)
			{
				choice=turn_unit(*r,*c);
				if(choice==TURN)
					action++;
				else if(choice==EXIT)
					choice=NONE;
			}//end if
			else if(choice==ATTACK)
			{
				choice=attack_unit(r,c);
				if(choice==ATTACK)
					action++;
				else if(choice==EXIT)
					choice=NONE;
			}//end if
			else if(choice==EXIT)
				choice=NONE;
		}//end if
	}//end while
	
	if(choice!=QUIT&&choice!=EXIT&&action==2)
	{	
		choice=END_TURN;
		for(row=0;row<8;row++)
		{
			for(col=0;col<9;col++)
			{
				if((turn==PLAYER1&&board[row][col].type>0)||(turn==PLAYER2&&board[row][col].type<0))
					board[row][col].attacked=FALSE;
			}//end for
		}//end for
	}//end if	
	
	return choice;
}//end player_turn()

void main_game(void)
{
	int r=4,c=4,exit=NONE;
	
	if(load_current_game())
		draw_board(r,c);
	else
		game_init(r,c);
	
	while(exit!=QUIT)
	{
		exit=menu(LCD_WIDTH/2-28,LCD_HEIGHT/2-34,MAIN);
		if(exit==NEW)
			game_init(r,c);
		else if(exit==SAVE)
			exit=save_game(LCD_WIDTH/2-37,LCD_HEIGHT/2-26);
		else if(exit==LOAD)
		{
			exit=load_game(LCD_WIDTH/2-37,LCD_HEIGHT/2-26);
			if(exit==SAVE_LOAD)
				draw_board(r,c);
		}//end if
		else if(exit==CUSTOM)
			exit=EXIT;
		else if(exit==HELP)
			exit=EXIT;
		
		while(exit!=QUIT&&exit!=EXIT)
		{
			exit=player_turn(&r,&c);
			if(exit==END_TURN)
			{action=0;(turn==PLAYER1)?(turn=PLAYER2):(turn=PLAYER1);}
		}//end while
	}//end while
	
	save_current_game();
}//end main_game()
