// C Header File
// Created 7/16/19; 2:52:33 AM

void GraySprite16(int x,int y,unsigned short *sprite,int mode)
{
	Sprite16(x,y,16,sprite,GetPlane(DARK_PLANE),mode);
  Sprite16(x,y,16,sprite+16,GetPlane(LIGHT_PLANE),mode);
}//end GraySprite16()

void DrawGrayLine(int x0,int y0,int x1,int y1,int mode,int gray_mode)
{
	if(gray_mode==0)
	{
		SetPlane(LIGHT_PLANE);
		DrawLine(x0,y0,x1,y1,mode);
	}//end if
	else if(gray_mode==1)
	{
		SetPlane(DARK_PLANE);
		DrawLine(x0,y0,x1,y1,mode);
	}//end if
	else
	{
		SetPlane(LIGHT_PLANE);
		DrawLine(x0,y0,x1,y1,mode);
		SetPlane(DARK_PLANE);
		DrawLine(x0,y0,x1,y1,mode);
	}//end if
}//end DrawGrayLine()

void DrawGrayBox(int x0,int y0,int x1,int y1,int color)
{
	int y;
	for(y=y0;y<=y1;y++)
		DrawGrayLine(x0,y,x1,y,A_XOR,color);
}//end DrawGrayBox()

void ClearGrayBox(int x1,int y1,int x2,int y2,int color)
{
	int a;
	for(a=y1;a<=y2;a++)
		DrawGrayLine(x1,a,x2,a,A_REVERSE,color);
}//end ClearGrayBox()

void DrawGrayRect(int x0,int y0,int x1,int y1,int style)
{
	if(style==0)
	{
		DrawGrayLine(x0,y0,x1,y0,A_NORMAL,LIGHT_GRAY);
		DrawGrayLine(x0,y0,x0,y1,A_NORMAL,LIGHT_GRAY);
		DrawGrayLine(x1,y0,x1,y1,A_NORMAL,LIGHT_GRAY);
		DrawGrayLine(x0,y1,x1,y1,A_NORMAL,LIGHT_GRAY);
		
		DrawGrayLine(x0-1,y0-1,x1+1,y0-1,A_NORMAL,DARK_GRAY);
		DrawGrayLine(x0-1,y0-1,x0-1,y1+1,A_NORMAL,DARK_GRAY);
		DrawGrayLine(x1+1,y0-1,x1+1,y1+1,A_NORMAL,DARK_GRAY);
		DrawGrayLine(x0-1,y1+1,x1+1,y1+1,A_NORMAL,DARK_GRAY);
		
		DrawGrayLine(x0-2,y0-2,x1+2,y0-2,A_NORMAL,DARK);
		DrawGrayLine(x0-2,y0-2,x0-2,y1+2,A_NORMAL,DARK);
		DrawGrayLine(x1+2,y0-2,x1+2,y1+2,A_NORMAL,DARK);
		DrawGrayLine(x0-2,y1+2,x1+2,y1+2,A_NORMAL,DARK);
	}//end if
	else
	{
		DrawGrayLine(x0,y0,x1,y0,A_NORMAL,DARK);
		DrawGrayLine(x0,y0,x0,y1,A_NORMAL,DARK);
		DrawGrayLine(x1,y0,x1,y1,A_NORMAL,DARK);
		DrawGrayLine(x0,y1,x1,y1,A_NORMAL,DARK);
		
		DrawGrayLine(x0-1,y0-1,x1+1,y0-1,A_NORMAL,DARK_GRAY);
		DrawGrayLine(x0-1,y0-1,x0-1,y1+1,A_NORMAL,DARK_GRAY);
		DrawGrayLine(x1+1,y0-1,x1+1,y1+1,A_NORMAL,DARK_GRAY);
		DrawGrayLine(x0-1,y1+1,x1+1,y1+1,A_NORMAL,DARK_GRAY);
		
		DrawGrayLine(x0-2,y0-2,x1+2,y0-2,A_NORMAL,LIGHT_GRAY);
		DrawGrayLine(x0-2,y0-2,x0-2,y1+2,A_NORMAL,LIGHT_GRAY);
		DrawGrayLine(x1+2,y0-2,x1+2,y1+2,A_NORMAL,LIGHT_GRAY);
		DrawGrayLine(x0-2,y1+2,x1+2,y1+2,A_NORMAL,LIGHT_GRAY);
	}//end else
}//end DrawGrayRect()
